Index: tmp/org.txm.treetagger.rcp/src/org/txm/treetagger/rcp/handlers/XMLLemmaProjection.java
===================================================================
--- tmp/org.txm.treetagger.rcp/src/org/txm/treetagger/rcp/handlers/XMLLemmaProjection.java	(revision 0)
+++ tmp/org.txm.treetagger.rcp/src/org/txm/treetagger/rcp/handlers/XMLLemmaProjection.java	(revision 687)
@@ -0,0 +1,193 @@
+package org.txm.treetagger.rcp.handlers;
+
+import java.io.File;
+import java.io.IOException;
+import java.util.HashSet;
+import java.util.LinkedHashMap;
+import java.util.LinkedHashSet;
+import java.util.regex.Pattern;
+
+import javax.xml.stream.XMLStreamException;
+
+import org.txm.importer.StaxIdentityParser;
+
+public class XMLLemmaProjection extends StaxIdentityParser {
+
+	// form -> pos -> source -> lemma
+	protected LinkedHashMap<String, LinkedHashMap<String, LinkedHashMap<String, String>>> rules = null;
+	protected HashSet<String> formAsLemmaPosList = null;
+	protected String lemmaProperty;
+
+	protected HashSet<String> noMatchValues = new HashSet<String>();
+	protected String posProperty;
+	protected LinkedHashSet<String> lemmaSourcePriorityList;
+
+	public XMLLemmaProjection(File infile, LinkedHashMap<String, LinkedHashMap<String, 
+			LinkedHashMap<String, String>>> rules, 
+			HashSet<String> formAsLemmaPosList,
+			LinkedHashSet<String> lemmaSourcePriorityList, 
+			String posProperty, String lemmaProperty) throws IOException, XMLStreamException {
+		super(infile);
+		this.rules = rules;
+		this.formAsLemmaPosList = formAsLemmaPosList;
+		this.lemmaSourcePriorityList = lemmaSourcePriorityList;
+		this.lemmaProperty = lemmaProperty;
+		this.posProperty = posProperty;
+		
+		// the XML-TXM files word properties name starts wit # (they are references)
+		if (!this.lemmaProperty.startsWith("#")) this.lemmaProperty = "#"+this.lemmaProperty;
+		if (!this.posProperty.startsWith("#")) this.posProperty = "#"+this.posProperty;
+	}
+
+	boolean inW = false, inAna = false, inForm;
+	LinkedHashMap<String, String> anaValues = new LinkedHashMap<String, String>();
+	LinkedHashMap<String, String> anaResps = new LinkedHashMap<String, String>();
+	String typeName = null;
+	String respName = null;
+	String formValue, typeValue = null;
+
+	@Override
+	public void processStartElement() throws XMLStreamException, IOException {
+		if (!inW) super.processStartElement(); // don't write W content
+
+		if (localname.equals("w")) {
+			inW = true;
+			anaValues.clear();
+			anaResps.clear();
+
+			//initialize the new type to a empty value in case there is transformation rule
+			anaValues.put(lemmaProperty, "");
+			anaResps.put(lemmaProperty, "#txm_recode");
+		} else if (localname.equals("ana")) {
+			inAna = true;
+			typeName = parser.getAttributeValue(null, "type");
+			respName = parser.getAttributeValue(null, "resp");
+			anaResps.put(typeName, respName);
+			//if (typeName != null) typeName = typeName.substring(1); // remove #
+			typeValue = "";
+		} else if (localname.equals("form")) {
+			inForm = true;
+			formValue = "";
+		} 
+	}
+
+	@Override
+	public void processCharacters() throws XMLStreamException {
+		if (inW && inAna) typeValue+=parser.getText();
+		else if (inW && inForm) formValue+=parser.getText();
+		else super.processCharacters();
+	}
+
+	@Override
+	public void processEndElement() throws XMLStreamException {
+		if (localname.equals("w")) {
+			inW = false;
+
+			// write W content
+			try {
+				// get the value to test
+				String posValue = anaValues.get(posProperty);
+				if (posValue == null) {
+					posValue = "<no_pos>";
+//					anaValues.put(posProperty, "<no_pos>");
+//					anaResps.put(posProperty, "txm_recode");
+				}
+				String value = updateAnaValuesIfMatch(formValue.trim(), posValue.trim());
+				//System.out.println("form="+formValue+" + pos="+posValue+" -> "+value);
+				anaValues.put(lemmaProperty, value);
+				anaResps.put(lemmaProperty, "#txm_recode");
+				
+				// write the word element
+				writer.writeStartElement("txm:form");
+				writer.writeCharacters(formValue);
+				writer.writeEndElement();
+
+				for (String k : anaValues.keySet()) {
+					writer.writeStartElement("txm:ana");
+					writer.writeAttribute("resp", anaResps.get(k));
+					writer.writeAttribute("type", k);
+					writer.writeCharacters(anaValues.get(k));
+					writer.writeEndElement();
+				}
+			} catch (XMLStreamException e) {
+				e.printStackTrace();
+			}
+		} else if (localname.equals("ana")) {
+			anaValues.put(typeName, typeValue);
+			inAna = false;
+		} else if (localname.equals("form")) {
+			inForm = false;
+		} 
+
+		if (!inW) super.processEndElement(); // don't write W content now
+	}
+
+	protected String updateAnaValuesIfMatch(String formValue, String posValue) {
+		if (posValue == null) return "";
+		
+		if (formAsLemmaPosList.contains(posValue)) return formValue;
+		
+		
+		if (formValue.equals("virge")) System.out.println("testing: "+formValue+" "+posValue);
+		if (formValue.equals("virge")) System.out.println("form connue? "+rules.containsKey(formValue));
+		if (rules.containsKey(formValue)) {
+			LinkedHashMap<String, LinkedHashMap<String, String>> posHash = rules.get(formValue);
+//			if (posHash.containsKey(posValue)) {
+//				LinkedHashMap<String, String> sourceHash = posHash.get(posValue);
+//				for (String source : lemmaSourcePriorityList) {
+//					if (sourceHash.containsKey(source)) {
+//						return sourceHash.get(source);
+//					}
+//				}
+//			}
+			if (formValue.equals("virge")) System.out.println(" tests"+posHash.keySet());
+			for (String posRegexp : posHash.keySet()) {
+				
+				if (posValue.matches(posRegexp)) {
+					return posHash.get(posRegexp).toString();
+				}
+			}
+		}
+		
+		// try without maj
+		String formValueMin = formValue.toLowerCase();
+		if (rules.containsKey(formValueMin)) {
+			LinkedHashMap<String, LinkedHashMap<String, String>> posHash = rules.get(formValueMin);
+//			if (posHash.containsKey(posValue)) {
+//				LinkedHashMap<String, String> sourceHash = posHash.get(posValue);
+//				for (String source : lemmaSourcePriorityList) {
+//					if (sourceHash.containsKey(source)) {
+//						return sourceHash.get(source);
+//					}
+//				}
+//			}
+			
+			for (String posRegexp : posHash.keySet()) {
+				if (posValue.matches(posRegexp)) {
+					return posHash.get(posRegexp).toString();
+				}
+			}
+		}
+		
+		noMatchValues.add(formValue+"|"+posValue);
+		return "!"+formValue;
+	}
+
+	public HashSet<String> getNoMatchValues() {
+		return noMatchValues;
+	}
+
+	public static void main(String args[]) {
+		File xmlFile = new File("/home/mdecorde/TXM/corpora/XTZTEXTUALPLANS/txm/XTZTEXTUALPLANS/test.xml");
+		File tmpFile = new File("/home/mdecorde/TXM/corpora/XTZTEXTUALPLANS/txm/XTZTEXTUALPLANS/test-o.xml");
+		String posProperty = "type";
+		String newType = "lemma";
+		LinkedHashMap<Pattern[], String> rules = new LinkedHashMap<Pattern[], String>();
+		rules.put(new Pattern[]{Pattern.compile("w"), Pattern.compile("w")}, "WORD");
+		rules.put(new Pattern[]{Pattern.compile("x.+"), Pattern.compile("w")}, "XWORD");
+		rules.put(new Pattern[]{Pattern.compile("y"), Pattern.compile("w")}, "YWORD");
+		rules.put(new Pattern[]{Pattern.compile("y.*"), Pattern.compile("w")}, "YMULTIWORD");
+		//XMLPropertyProjection converter = new XMLPropertyProjection(xmlFile, rules, posProperty, newType);
+		//System.out.println(converter.process(tmpFile));
+	}
+}

Index: tmp/org.txm.treetagger.rcp/src/org/txm/treetagger/rcp/handlers/RemoveProperties.java
===================================================================
--- tmp/org.txm.treetagger.rcp/src/org/txm/treetagger/rcp/handlers/RemoveProperties.java	(revision 0)
+++ tmp/org.txm.treetagger.rcp/src/org/txm/treetagger/rcp/handlers/RemoveProperties.java	(revision 687)
@@ -0,0 +1,144 @@
+package org.txm.treetagger.rcp.handlers;
+
+import java.io.BufferedReader;
+import java.io.File;
+import java.io.FileFilter;
+import java.util.Arrays;
+import java.util.HashSet;
+import java.util.LinkedHashMap;
+import java.util.LinkedHashSet;
+
+import org.apache.commons.lang.StringUtils;
+import org.eclipse.core.commands.AbstractHandler;
+import org.eclipse.core.commands.ExecutionEvent;
+import org.eclipse.core.commands.ExecutionException;
+import org.eclipse.core.runtime.IProgressMonitor;
+import org.eclipse.core.runtime.IStatus;
+import org.eclipse.core.runtime.Status;
+import org.eclipse.jface.viewers.ISelection;
+import org.eclipse.jface.viewers.IStructuredSelection;
+import org.eclipse.ui.IWorkbenchWindow;
+import org.eclipse.ui.handlers.HandlerUtil;
+import org.kohsuke.args4j.Option;
+import org.txm.Toolbox;
+import org.txm.core.preferences.TBXPreferences;
+import org.txm.core.preferences.TXMPreferences;
+import org.txm.rcp.swt.widget.parameters.ParametersDialog;
+import org.txm.rcp.utils.JobHandler;
+import org.txm.searchengine.cqp.clientExceptions.CqiClientException;
+import org.txm.searchengine.cqp.corpus.Corpus;
+import org.txm.searchengine.cqp.corpus.MainCorpus;
+import org.txm.searchengine.cqp.corpus.Property;
+import org.txm.stat.utils.ConsoleProgressBar;
+import org.txm.utils.DeleteDir;
+import org.txm.utils.io.FileCopy;
+import org.txm.utils.io.IOUtils;
+import org.txm.utils.Tuple;
+
+/**
+ * Our sample handler extends AbstractHandler, an IHandler base class.
+ * @see org.eclipse.core.commands.IHandler
+ * @see org.eclipse.core.commands.AbstractHandler
+ */
+public class RemoveProperties extends AbstractHandler {
+
+	@Option(name="propertiesList", usage="The properties to remove", widget="String", required=true, def="plemma")
+	public String propertiesList = null;
+
+	/**
+	 * 
+	 */
+	public Object execute(ExecutionEvent event) throws ExecutionException {
+		Corpus corpus = null;
+		IWorkbenchWindow window = HandlerUtil.getActiveWorkbenchWindowChecked(event);
+
+		ISelection isel = window.getActivePage().getSelection();
+		if (isel instanceof IStructuredSelection) {
+			IStructuredSelection sel = (IStructuredSelection)isel;
+			Object first = sel.getFirstElement();
+			if (first instanceof Corpus) {
+				corpus = (Corpus)first;
+				if (ParametersDialog.open(this)) {
+					LinkedHashSet<String> propertiesSet = new LinkedHashSet<String>();
+					propertiesSet.addAll(Arrays.asList(propertiesList.split(",")));
+					
+					apply(corpus, propertiesSet);
+					return corpus;
+				}
+			}
+		}
+
+		System.out.println("Wrong selection.");
+		return null;
+	}
+
+	public static void apply(final Corpus corpus, final HashSet<String> propertiesSet) {
+		final MainCorpus mainCorpus = corpus.getMainCorpus();
+		final File corpusBinaryDirectory = mainCorpus.getBaseDirectory();
+		final File txmDirectory = new File(corpusBinaryDirectory, "txm/"+mainCorpus.getName());
+
+		if (!txmDirectory.exists()) {
+			System.out.println("Can't process a corpus with no XML-TXM files directory: "+txmDirectory);
+			return;
+		}
+
+		final File[] files = txmDirectory.listFiles(new FileFilter() {
+			@Override
+			public boolean accept(File file) {
+				return file.isFile() && file.canWrite() && file.getName().endsWith(".xml");
+			}
+		});
+
+		if (files == null || files.length == 0) {
+			System.out.println("Can't process a corpus with no XML-TXM files in "+txmDirectory);
+			return;
+		}
+
+		System.out.println("Removing "+propertiesSet+" to "+mainCorpus+" XML-TXM files...");
+		JobHandler job = new JobHandler("Removing "+propertiesSet+" to "+mainCorpus+" XML-TXM files.") {
+			@Override
+			protected IStatus run(IProgressMonitor monitor) {
+				this.runInit(monitor);
+				LinkedHashMap<String, LinkedHashMap<String, LinkedHashMap<String, String>>> rules = new LinkedHashMap<String, LinkedHashMap<String, LinkedHashMap<String, String>>>();
+				HashSet<String> no_change_rules = new HashSet<String>();
+				try {
+					// save previous version of XML-TXM files
+					File previousXMLTXMDirectory = new File(txmDirectory.getAbsolutePath()+"_previous");
+					DeleteDir.deleteDirectory(previousXMLTXMDirectory);
+					FileCopy.copyFiles(txmDirectory, previousXMLTXMDirectory);
+
+					// work
+					File noMatchsFile = new File(TXMPreferences.getString(TBXPreferences.USER_TXM_HOME, TBXPreferences.PREFERENCES_NODE), "results/nomatch.txt");
+					HashSet<String> noMatchsSet = new HashSet<String>();
+					ConsoleProgressBar cpb = new ConsoleProgressBar(files.length);
+					for (File xmlFile : files) {
+						cpb.tick();
+						XMLRemoveProperties p = new XMLRemoveProperties(xmlFile, propertiesSet);
+						File tmpFile = new File(xmlFile.getParentFile(), "tmp_"+xmlFile.getName());
+						if (p.process(tmpFile)) {
+							if (xmlFile.delete() && tmpFile.renameTo(xmlFile)) {
+								// ok
+							} else {
+								System.out.println("Error during properties removal: can't replace XML-TXM file: "+xmlFile);
+								return Status.CANCEL_STATUS;
+							}
+						} else {
+							System.out.println("Error during properties removal. Aborting.");
+							return Status.CANCEL_STATUS;
+						}
+					}
+
+					cpb.done();
+					monitor.worked(50);
+
+				} catch (Exception e) {
+					e.printStackTrace();
+					return Status.CANCEL_STATUS;
+				}
+				System.out.println("Done.");
+				return Status.OK_STATUS;
+			}
+		};
+		job.schedule();
+	}
+}

Index: tmp/org.txm.treetagger.rcp/src/org/txm/treetagger/rcp/handlers/XMLRemoveProperties.java
===================================================================
--- tmp/org.txm.treetagger.rcp/src/org/txm/treetagger/rcp/handlers/XMLRemoveProperties.java	(revision 0)
+++ tmp/org.txm.treetagger.rcp/src/org/txm/treetagger/rcp/handlers/XMLRemoveProperties.java	(revision 687)
@@ -0,0 +1,90 @@
+package org.txm.treetagger.rcp.handlers;
+
+import java.io.File;
+import java.io.IOException;
+import java.util.HashSet;
+import java.util.LinkedHashMap;
+import java.util.regex.Pattern;
+
+import javax.xml.stream.XMLStreamException;
+
+import org.txm.importer.StaxIdentityParser;
+
+/**
+ * Remove XML-TXM file ana elements which 'type' attribute value is in a set
+ * 
+ * @author mdecorde
+ *
+ */
+public class XMLRemoveProperties extends StaxIdentityParser {
+
+	// form -> pos -> source -> lemma
+	protected HashSet<String> propertiesSet = null;
+
+	/**
+	 * 
+	 * @param infile the XML-TXM file to process
+	 * @param propertiesSet the set of ana@type attributes to remove
+	 * @throws XMLStreamException 
+	 * @throws IOException 
+	 */
+	public XMLRemoveProperties(File infile, HashSet<String> propertiesSet) throws IOException, XMLStreamException {
+		super(infile);
+		this.propertiesSet = new HashSet<String>();
+		for (String property : propertiesSet) {
+			// the XML-TXM files word properties name starts with # (they are references)
+			if (!property.startsWith("#")) property = "#"+property;
+			this.propertiesSet.add(property);
+		}
+	}
+
+	boolean inW = false, inAna = false;
+	String typeName = null;
+	@Override
+	public void processStartElement() throws XMLStreamException, IOException {
+		
+		if (localname.equals("w")) {
+			inW = true;
+		} else if (inW && localname.equals("ana")) {
+			inAna = true;
+			typeName = parser.getAttributeValue(null, "type");
+			if (propertiesSet.contains(typeName)) return; // don't write this element start tag
+		}
+		
+		super.processStartElement();
+	}
+
+	@Override
+	public void processCharacters() throws XMLStreamException {
+		
+		if (inW && typeName != null && propertiesSet.contains(typeName)) {return;} // don't write the element content
+		super.processCharacters();
+	}
+
+	@Override
+	public void processEndElement() throws XMLStreamException {
+		if (localname.equals("w")) {
+			inW = false;
+		} else if (inW && localname.equals("ana")) {
+			inAna = false;
+			if (propertiesSet.contains(typeName)) {typeName = null; return;} // don't write the element end tag
+			typeName = null;
+		}
+
+		super.processEndElement(); // don't write W content now
+	}
+
+	public static void main(String args[]) {
+		File xmlFile = new File("/home/mdecorde/TXM/corpora/XTZTEXTUALPLANS/txm/XTZTEXTUALPLANS/test.xml");
+		File tmpFile = new File("/home/mdecorde/TXM/corpora/XTZTEXTUALPLANS/txm/XTZTEXTUALPLANS/test-o.xml");
+		String posProperty = "type";
+		String newType = "lemma";
+		LinkedHashMap<Pattern[], String> rules = new LinkedHashMap<Pattern[], String>();
+		rules.put(new Pattern[]{Pattern.compile("w"), Pattern.compile("w")}, "WORD");
+		rules.put(new Pattern[]{Pattern.compile("x.+"), Pattern.compile("w")}, "XWORD");
+		rules.put(new Pattern[]{Pattern.compile("y"), Pattern.compile("w")}, "YWORD");
+		rules.put(new Pattern[]{Pattern.compile("y.*"), Pattern.compile("w")}, "YMULTIWORD");
+		//XMLPropertyProjection converter = new XMLPropertyProjection(xmlFile, rules, posProperty, newType);
+		//System.out.println(converter.process(tmpFile));
+	}
+}

